###############################################################################
### MAPPING:
###   SOURCE: {{ mapping["source"] }}
###   TARGET: {{ mapping["target"] }}
###############################################################################

{%- set proxy_headers = {} %}
{%- macro proxy_set_header(header, value) %}
{%- set _ = proxy_headers.update({header: value}) %}
{%- endmacro %}
{%- macro render_proxy_headers() %}
{%- for header, value in proxy_headers.items() %}
proxy_set_header {{ header }} {{ value }};
{%- endfor %}
{%- endmacro %}

{%- set resp_headers = {} %}
{%- macro resp_set_header(header, value) %}
{%- set _ = resp_headers.update({header: value}) %}
{%- endmacro %}
{%- macro render_resp_headers() %}
{%- for header, value in resp_headers.items() %}
add_header {{ header }} {{ value }} always;
{%- endfor %}
{%- endmacro %}

{%- set upstream_id = "{}_{}".format(mapping["source"], mapping["target"]) | hash("md5") %}

{%- set target_scheme = mapping["target"] | urlsplit("scheme") %}
{%- set target_host = mapping["target"] | urlsplit("hostname") %}
{%- set target_port = mapping["target"] | urlsplit("port") %}

{%- set source_scheme = mapping["source"] | urlsplit("scheme") %}
{%- set source_host = mapping["source"] | urlsplit("hostname") %}
{%- set source_port = mapping["source"] | urlsplit("port") %}

{%- set src_path = mapping["source"] | urlsplit("path") %}
{%- set tgt_path = mapping["target"] | urlsplit("path") %}

{%- if src_path is not regex("/$") %}
  {%- set src_path = src_path + "/" %}
{%- endif %}
{%- if tgt_path is not regex("/$") %}
  {%- set tgt_path = tgt_path + "/" %}
{%- endif %}

{%- if saml_enabled and mapping["saml_config"] is not none %}
{% include "nginx-service-mapping-saml.j2" %}
{%- endif %}

###############################################################################
### Reverse proxy configuration

{%- if src_path != "/" %}
location = {{ src_path[:-1] }} {
  rewrite ^ {{ src_path }} permanent;
}
{%- endif %}

location ~ {{ src_path }}(.*) {
  set $mapping_id {{ mapping["id"] }};

  {%- if saml_enabled and mapping["saml_config"] is not none %}
    {%- set saml_flow_location = "@samlsp_flow_mapping_" + mapping["id"] %}
  error_page 401 = {{ saml_flow_location }};

  if ($saml_access_granted != "1") {
    return 401;
  }

  proxy_set_header username $saml_name_id;
  {%- endif %}

  client_max_body_size {{ mapping["client_max_body_size"] }}M;

  rewrite ^{{ src_path }}(.*) {{ tgt_path }}$1 break;

  proxy_pass {{ target_scheme }}://{{ upstream_id }};
  {{- proxy_set_header("Host", "'{}{}'".format(source_host, source_port|ternary(":{}".format(source_port), ""))) }}
  {{- proxy_set_header("Client-IP", "$remote_addr") }}
  {{- proxy_set_header("X-Forwarded-Scheme", source_scheme) }}
  {{- proxy_set_header("X-Forwarded-Proto", source_scheme) }}
  {{- proxy_set_header("X-Forwarded-Host", "'{}{}'".format(source_host, source_port|ternary(":{}".format(source_port), ""))) }}
  {{- proxy_set_header("X-Forwarded-Port", "'{}'".format(service["port"])) }}
  {{- proxy_set_header("X-Forwarded-For", "$proxy_add_x_forwarded_for") }}
  {{- proxy_set_header("X-Real-Ip", "$remote_addr") }}

  {%- if "websocket" in mapping["extra_protocols"] %}
    {{- proxy_set_header("Upgrade", "$http_upgrade") }}
    {{- proxy_set_header("Connection", "upgrade") }}
  {%- else %}
    {{- proxy_set_header("Connection", '""') }}
  {%- endif %}

  {%- for header in mapping["http_headers"] %}
    {%- if header["apply_to"] == "request" %}
      {{- proxy_set_header(header["name"], header["value"]) }}
    {%- elif header["apply_to"] == "response" %}
      {{- resp_set_header(header["name"], header["value"]) }}
    {%- endif %}
  {%- endfor %}

  {%- set dynatrace_header = mapping["source"]|regex_replace("https?:\/\/", "") %}
  {{- proxy_set_header("x-digitc-dynatrace", dynatrace_header) }}

  {{ render_proxy_headers() | indent(2) }}

  {{ render_resp_headers() | indent(2) }}

  keepalive_timeout  {{ mapping["keepalive_timeout"] }};
  keepalive_requests  {{ mapping["keepalive_requests"] }};

  {%- if not mapping["proxy_cache"] %}
  proxy_cache off;
  {%- endif %}

  {%- if not mapping["gzip_proxied"] %}
  gzip_proxied off;
  {%- endif %}

  proxy_read_timeout {{ mapping["proxy_read_timeout"] }}s;

  {%- if mapping["sorry_page"] %}
  error_page 500 502 503 504 =307 {{ mapping["sorry_page"] }};
  {%- else %}
  error_page 500 502 503 504 =307 $default_sorry;
  {%- endif %}

  proxy_redirect "{{ mapping["target"] }}" "{{ mapping["source"]}}";
  proxy_redirect "https://ecas.cc.cec.eu.int:7002/cas" "https://ecas.ec.europa.eu/cas";

  ## TODO: 'has standard rewrites' NOT YET SUPPORTED
  #sub_filter_once off;
  #sub_filter "{{ mapping["target"] }}" "{{ mapping["source"] }}";
  #sub_filter "src='{{ tgt_path }}"     "src='{{ src_path }}";
  #sub_filter 'src="{{ tgt_path }}'     'src="{{ src_path }}';
  #sub_filter "href='{{ tgt_path }}"    "href='{{ src_path }}";
  #sub_filter 'href="{{ tgt_path }}'    'href="{{ src_path }}';
  #sub_filter "action='{{ tgt_path }}"  "action='{{ src_path }}";
  #sub_filter 'action="{{ tgt_path }}'  'action="{{ src_path }}';
}
